set noerrorbells
set history=500
set autoread
set ruler
set number
set expandtab
set smarttab
set smartindent
set nowrap
set smartcase
set noswapfile
set nobackup
set undodir=~/.nvim/undodir
set undofile
set incsearch
set shiftwidth=4
set tabstop=4 softtabstop=4
set encoding=utf-8
set fileencoding=utf-8
set relativenumber
set scrolloff=8
set hidden
set signcolumn=yes
set colorcolumn=110

autocmd BufWritePost *.tex !echo | pdflatex % >/dev/null

call plug#begin("~/.nvim/plugged")
Plug 'rust-lang/rust.vim'
Plug 'nvim-treesitter/nvim-treesitter', {'do': ':TSUpdate'}
Plug 'neovim/nvim-lspconfig'
Plug 'mbbill/undotree'
Plug 'sbdchd/neoformat'
Plug 'gruvbox-community/gruvbox'
Plug 'folke/tokyonight.nvim', { 'branch': 'main' }
Plug 'nvim-lua/plenary.nvim'
Plug 'nvim-telescope/telescope.nvim'
Plug 'nvim-telescope/telescope-fzy-native.nvim'
Plug 'psliwka/vim-smoothie'
Plug 'darrikonn/vim-gofmt', { 'do': ':GoUpdateBinaries' }
"Plug 'fatih/vim-go'
Plug 'preservim/nerdtree'
Plug 'udalov/kotlin-vim'

Plug 'hrsh7th/cmp-nvim-lsp'
Plug 'hrsh7th/cmp-buffer'
Plug 'hrsh7th/nvim-cmp'
Plug 'L3MON4D3/LuaSnip'
Plug 'EdenEast/nightfox.nvim'
Plug 'itchyny/lightline.vim'
"EEEEEEEEEEEEEEEEEEEEEEEEEEEee
Plug 'ThePrimeagen/vim-be-good'
Plug 'tpope/vim-fugitive'
Plug 'simrat39/rust-tools.nvim'

call plug#end()

"colorscheme gruvbox
colorscheme tokyonight

let mapleader = " "

nnoremap <C-p> :lua require ('telescope.builtin').git_files()<CR>
nnoremap <C-f> :lua require ('telescope.builtin').find_files()<CR>
nnoremap <leader>f :lua require('telescope.builtin').live_grep()<CR>
nnoremap <leader><tab> :lua require('telescope.builtin').buffers()<CR>
"nnoremap <leader><tab> :b<space>
nnoremap <leader>y "+y

lua require("init")

nnoremap gd :lua vim.lsp.buf.definition()<CR>
nnoremap K  :lua vim.lsp.buf.hover()<CR>
nnoremap L  :lua vim.diagnostic.open_float()<CR>

"autocmd BufWritePost *.go GoImports

nnoremap <C-n> :NERDTreeToggle<CR>
